'''
Created on 30 mai 2011

@author: M
'''

import math

class Point:

    def __init__(self,x,y):
        self.x=x
        self.y=y
        
    def distance(self,p):
        return math.sqrt((self.x-p.x)**2+(self.y-p.y)**2)

class BasicCell:
    
    def __init__(self,x,y,d_x,d_y):
        self.x=float(x)
        self.y=float(y)
        self.d_x=float(d_x)
        self.d_y=float(d_y)
        
    def size(self):
        return self.d_x*self.d_y

class Cell(BasicCell):
    
    def __init__(self,x,y,d_x,d_y):
        self.points=list()
        BasicCell.__init__(self, float(x), float(y), float(d_x), float(d_y))
        self.grided=list()
	self.id = 0
    
    def getCount(self):
        return len(self.points)

    def addPoint(self,p):
        self.points.append(p)
    
    def makeGrid(self,x_step,y_step):
        x=self.x
        y=self.y

	cache = {}

	col_num = math.ceil(float(self.x - (self.x - self.d_x)) / x_step) 
	row_num = math.ceil(float(self.y - (self.y - self.d_y)) / y_step) 
        
        l=list()
	tmp_list = list()
	row = 0
        while x>self.x-self.d_x:
            ylist=list()
            y=self.y
	    col = 0
            if x-x_step>self.x-self.d_x:
                while y>self.y-self.d_y:
                    if y-y_step>self.y-self.d_y:
                        area=Cell(x,y,x_step,y_step)
			area.id = row * col_num + col
			cache[area.id] = area
                        l.append(area)
                        ylist.append(area)
                    else:
                        area=Cell(x,y,x_step,y-(self.y-self.d_y))
			area.id = row * col_num + col
			cache[area.id] = area
                        l.append(area)
                        ylist.append(area)
                    y-=y_step
		    col += 1
            else:
                while y>self.y-self.d_y:
                    if y-y_step>self.y-self.d_y:
                        area=Cell(x,y,x-(self.x-self.d_x),y_step)
			area.id = row * col_num + col
			cache[row * col_num + col] = area
                        l.append(area)
                        ylist.append(area)
                    else:
                        area=Cell(x,y,x-(self.x-self.d_x),y-(self.y-self.d_y))
			area.id = row * col_num + col
			cache[area.id] = area
                        l.append(area)
                        ylist.append(area)
                    y-=y_step
		    col += 1
            self.grided.append(ylist)
	    tmp_list.extend(ylist);
            x-=x_step
	    row += 1

	print ("Number of cells: ", row_num * col_num);
            
	max_population = 0
        for p in self.points:
	    area = cache[col_num * ((self.x - p.x) // x_step) + (self.y - p.y) // y_step]
	    area.addPoint(p)
	    if (max_population < len(area.points)): 
	    	max_population = len(area.points)
	
        return l
    
                
