'''
Created on 31 mai 2011

@author: M
'''

import sys

import math
import random

from Cell import *

if __name__=='__main__':   
    
    print(sys.getrecursionlimit())
    sys.setrecursionlimit(15000)
    
    if len(sys.argv)>1:
        dataset = sys.argv[1]
        x_step = sys.argv[2]
        y_step = sys.argv[3]
    else:
        x_step = 300
        y_step = 300
        dataset = "Waitakere"   

    histogram_name = "histogram.txt"

    print("Dataset: ", dataset)
    file = open("{0}_data.txt".format(dataset))
    value = file.readline().rstrip().split("\t") 
    map = Cell(value[0],value[1],value[2],value[3])

    print("Map created.")

    for line in file:
        value=line.rstrip().split("\t")
        map.addPoint(Point(float(value[0]),float(value[1]))) 

    print("Number of points", map.getCount())

    cells = map.makeGrid(x_step,y_step)

    #random.shuffle(cells)

    #to_remove = len(cells) - 2**int(math.log(len(cells),2))

    #rnd.seed(5);

    #for i in range(to_remove):
    #    cells.pop(random.randint(0, len(cells)-1))

    file = open(histogram_name,'w')
    for cell in cells:
        file.write(str(cell.getCount()) + "\n")
    
    file.close()

    print(histogram_name + " created.")






